local mod = foundation.createMod();

mod:registerAssetId("maps/HEIGHT_MAP_VP.png", "HEIGHT_MAP")
mod:registerAssetId("maps/MATERIAL_MASK_VP.png", "MATERIAL_MASK")
mod:registerAssetId("maps/flat_density.png", "FLAT_DENSITY_MAP")
mod:registerAssetId("maps/mountain_density.png", "MOUNTAIN_DENSITY_MAP")
mod:registerAssetId("maps/berries_density.png", "BERRIES_DENSITY_MAP")
mod:registerAssetId("maps/rock_density.png", "ROCK_DENSITY_MAP")
mod:registerAssetId("maps/fish_density.png", "FISH_DENSITY_MAP")

mod:register({
	DataType = "CUSTOM_MAP",
	Id = "MAP_VP_01",
	HeightMap = "HEIGHT_MAP",
	MaterialMask = "MATERIAL_MASK",
	MinHeight = -40,
	MaxHeight = 190,
	VillagePathList = {
		{
			Entrance = { 10, 0, 960 },
			Exit = { 1010, 0, 960 }
		},		
		{
			Entrance = { 1010, 0, 250 },
			Exit = { 10, 0, 250 }
		}
	},
	SpawnList = {
			------------------------------------------- 1 base
			{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 450 , 30 , 910 },  
			Orientation = { 0.0, 90.0 , 0.0},
			Scale = { 2, 2.5, 2 },
			PatchBeforeVersion = "1.0.0"
			},
			-------------------------------------------1
			{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 27 , 27 , 567 }, 
			Orientation = { 0.0, 90.0 , 0.0},
			Scale = { 2, 2, 2 },
			PatchBeforeVersion = "1.0.0"
			},
			------------------------------------------2
			{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 27 , 27 , 573 },  
			Orientation = { 0.0, 180.0 , 0.0},
			Scale = { 2, 2, 2 },
			PatchBeforeVersion = "1.0.0"
			},
			-------------------------------------------3
			{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 33 , 27 , 573 },   
			Orientation = { 0.0, 270.0 , 0.0},
			Scale = { 2, 2, 2 },
			PatchBeforeVersion = "1.0.0"
			},
			--------------------------------------------4
		    {
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 33 , 27 , 567 },  
			Orientation = { 0.0, 360.0 , 0.0},
			Scale = { 2, 2, 2 },
			PatchBeforeVersion = "1.0.0"
		    },
			-------------------------------------------- 2 base
			{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 150 , 30 , 800 }, 
			Orientation = { 0.0, 150.0 , 0.0},
			Scale = { 2, 2.5, 2 },
			PatchBeforeVersion = "1.0.0"
			},
			-------------------------------------------1
			{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 147 , 27 , 797 }, 
			Orientation = { 0.0, 90.0 , 0.0},
			Scale = { 2, 2, 2 },
			PatchBeforeVersion = "1.0.0"
			},
			------------------------------------------2
			{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 147 , 27 , 803 },  
			Orientation = { 0.0, 180.0 , 0.0},
			Scale = { 2, 2, 2 },
			PatchBeforeVersion = "1.0.0"
			},
			-------------------------------------------3
			{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 153 , 27 , 803 },   
			Orientation = { 0.0, 270.0 , 0.0},
			Scale = { 2, 2, 2 },
			PatchBeforeVersion = "1.0.0"
			},
			--------------------------------------------4
		    {
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 153 , 27 , 797 },  
			Orientation = { 0.0, 360.0 , 0.0},
			Scale = { 2, 2, 2 },
			PatchBeforeVersion = "1.0.0"
		    },
			---------------------------------------------- 3 base
			{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 450 , 65 , 910 },  
			Orientation = { 0.0, 35.0 , 0.0},
			Scale = { 2, 2.5, 2 },
			PatchBeforeVersion = "1.0.0"
			},
			-------------------------------------------1
			{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 447 , 67 , 907 }, 
			Orientation = { 0.0, 90.0 , 0.0},
			Scale = { 2.5, 2, 2 },
			PatchBeforeVersion = "1.0.0"
			},
			------------------------------------------2
			{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 447 , 67 , 913 },  
			Orientation = { 0.0, 180.0 , 0.0},
			Scale = { 2.5, 2, 2 },
			PatchBeforeVersion = "1.0.0"
			},
			-------------------------------------------3
			{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 453 , 67 , 913 },   
			Orientation = { 0.0, 270.0 , 0.0},
			Scale = { 2.5, 2, 2 },
			PatchBeforeVersion = "1.0.0"
			},
			--------------------------------------------4
		    {
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 453 , 67 , 907 },  
			Orientation = { 0.0, 360.0 , 0.0},
			Scale = { 2.5, 2, 2 },
			PatchBeforeVersion = "1.0.0"
		    },
			---------------------------------------------- 4 base
			{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 670 , 15 , 830 },   
			Orientation = { 0.0, 150.0 , 0.0},
			Scale = { 2.5, 2.8, 2 },
			PatchBeforeVersion = "1.0.0"
			},
			-------------------------------------------1
			{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 667 , 12 , 827 }, 
			Orientation = { 0.0, 90.0 , 0.0},
			Scale = { 2.5, 2.3, 2 },
			PatchBeforeVersion = "1.0.0"
			},
			------------------------------------------2
			{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 667 , 12 , 833 },  
			Orientation = { 0.0, 180.0 , 0.0},
			Scale = { 2.5, 2.3, 2 },
			PatchBeforeVersion = "1.0.0"
			},
			-------------------------------------------3
			{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 673 , 12 , 833 },   
			Orientation = { 0.0, 270.0 , 0.0},
			Scale = { 2.5, 2.3, 2 },
			PatchBeforeVersion = "1.0.0"
			},
			--------------------------------------------4
		    {
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 673 , 12 , 827 },  
			Orientation = { 0.0, 360.0 , 0.0},
			Scale = { 2.5, 2.3, 2 },
			PatchBeforeVersion = "1.0.0"
		    },
			--------------------------------------------- 5 base
		    {
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 980 , 20 , 560 },  
			Orientation = { 0.0, 80.0 , 0.0},
			Scale = { 2, 2.5, 2 },
			PatchBeforeVersion = "1.0.0"
		    },
		    -------------------------------------------1
			{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 977 , 17 , 557 }, 
			Orientation = { 0.0, 90.0 , 0.0},
			Scale = { 2, 2, 2 },
			PatchBeforeVersion = "1.0.0"
			},
			------------------------------------------2
			{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 977 , 17 , 563 },  
			Orientation = { 0.0, 180.0 , 0.0},
			Scale = { 2, 2, 2 },
			PatchBeforeVersion = "1.0.0"
			},
			-------------------------------------------3
			{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 983 , 17 , 563 },   
			Orientation = { 0.0, 270.0 , 0.0},
			Scale = { 2, 2, 2 },
			PatchBeforeVersion = "1.0.0"
			},
			--------------------------------------------4
		    {
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 983 , 17 , 557 },  
			Orientation = { 0.0, 360.0 , 0.0},
			Scale = { 2, 2, 2 },
			PatchBeforeVersion = "1.0.0"
		    }
		},	
	DensitySpawnList = {
			{
			DensityMap = "FLAT_DENSITY_MAP",
			Density = 0.8,  
			PrefabConfigList = {
			{
					PrefabList = { "PREFAB_TREE_OAK" },
					RandomWeight = .1,
					OffsetSizeRange = {
						Min = 0.5,
						Max = 3.0
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.6,
						Max = 2.0
					},
					ColorRange = {
						Min = { 0.3, 0.3, 0.3, 1 },
						Max = { 0.32, 0.32, 0.32, 2 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_OAK", "PREFAB_TREE_SYCAMORE", "PREFAB_TREE_OAK" },  
					RandomWeight = 3.0,   
					OffsetSizeRange = {   
						Min = 0.75,
						Max = 1.6
					},
					OrientationRange = {     
						Min = { 0, -180, 0 },
						Max = { 0, 180, 0 }
					},
					ScaleRange = {    
						Min = 0.9,
						Max = 1.3
					},
					ColorRange = {     
						Min = { 0.5, 0.5, 0.5, 1 },
						Max = { 0.7, 0.7, 0.7, 1 }
					}
				},	
				{
					PrefabList = { "PREFAB_TREE_OAK", "PREFAB_TREE_PINE" },
					RandomWeight = 2.0,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1.0
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.9,
						Max = 1.4
					},
					ColorRange = {
						Min = { 0.6, 0.6, 0.6, 1 },
						Max = { 0.7, 0.7, 0.7, 1}
					}
				}
			}
		},
		{
			DensityMap = "MOUNTAIN_DENSITY_MAP",
			Density = .9,
			PrefabConfigList = {
			{
					PrefabList = { "PREFAB_TREE_PINE" },
					RandomWeight = .1,
					OffsetSizeRange = {
						Min = 0.5,
						Max = 1.8
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.6,
						Max = 1.8
					},
					ColorRange = {
						Min = { 0.3, 0.3, 0.3, 1 },
						Max = { 0.32, 0.32, 0.32, 3 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_PINE" },
					RandomWeight = 1,
					OffsetSizeRange = {
						Min = 0.5,
						Max = 2.0
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.6,
						Max = 2.0
					},
					ColorRange = {
						Min = { 0.3, 0.3, 0.3, 1 },
						Max = { 0.32, 0.32, 0.32, 3 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_PINE", "PREFAB_TREE_OAK" },
					RandomWeight = 3,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1.6
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.7,
						Max = 1.6
					},
					ColorRange = {
						Min = { 0.6, 0.6, 0.6, 1 },
						Max = { 0.7, 0.7, 0.7, 3}
					}
				}
			}
		},
		{
			DensityMap = "BERRIES_DENSITY_MAP",
			Density = .3,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_BERRIES" },
					RandomWeight = 1,
					OffsetSizeRange = {
						Min = 1,
						Max = 1.5
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 1,
						Max = 1.5
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 2 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			DensityMap = "ROCK_DENSITY_MAP",
			Density = .3,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_ROCK" },
					RandomWeight = 1,
					OffsetSizeRange = {
						Min = 1,
						Max = 2
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 1,
						Max = 2
					},
					ColorRange = {
						Min = { 1, 1, 1, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			DensityMap = "FISH_DENSITY_MAP",
			Density = .4,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_FISH" },
					RandomWeight = 1,
					OffsetSizeRange = {
						Min = 1,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 1,
						Max = 1
					},
					ColorRange = {
						Min = { 1, 1, 1, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		}
	}
})

